BeanFactory (Apache Commons Configuration 2.15.1 API)
Description: declaration: package: org.apache.commons.configuration2.beanutils, interface: BeanFactory

Package org.apache.commons.configuration2.beanutils

# Interface BeanFactory

All Known Implementing Classes:
  `DefaultBeanFactory`

public interface BeanFactory

Definition of an interface for bean factories.

Beans defined in configuration files are not directly created, but by so called bean factories. This additional level of indirection provides for high flexibility in the creation process. For instance one implementation of this interface could be very simple and create a new instance of the specified class for each invocation. A different implementation could cache already created beans and ensure that always the same bean of the given class will be returned - this would be an easy mean for creating singleton objects.

The interface itself is quite simple. There is a single method for creating a bean of a given class. All necessary parameters are obtained from a passed in `BeanCreationContext` object. It is also possible (but optional) for a bean factory to declare the default class of the bean it creates. Then it is not necessary to specify a bean class in the bean declaration.

Since:
  1.3

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `createBean(BeanCreationContext bcc)`
  Creates a bean instance for the given context object.
  `Class<?>`
  `getDefaultBeanClass()`
  Gets the default bean class of this bean factory.

- ## Method Details

  - ### createBean

    Object createBean(BeanCreationContext bcc) throws Exception
    Creates a bean instance for the given context object. All information about the bean to be created are contained in the provided `BeanCreationContext` object. This includes a `BeanDeclaration` defining the properties of the bean. It is up to a concrete implementation how the bean is created and initialized.
    Parameters:
      `bcc` - the context object for the bean to be created
    Returns:
      the new bean instance (should not be null)
    Throws:
      `Exception` - if an error occurs (the helper classes for creating beans will catch this generic exception and wrap it in a configuration exception)

  - ### getDefaultBeanClass

    Class<?> getDefaultBeanClass()
    Gets the default bean class of this bean factory. If an implementation here returns a non null value, bean declarations using this factory do not need to provide the name of the bean class. In such a case an instance of the default class will be created.
    Returns:
      the default class of this factory or null if there is none